<template lang="pug">

  .container(v-loading="pageLoading")
    .activity__block(v-if='updatedCategory')
      p.create-date-lable Обновлено {{ updatedCategory }}
    .block-typical

      el-form.flex-form(
        ref='categoriesForm'
        v-if="inputs.length"
        :model='stateForm'
        :rules="rules")

        el-form-item(
          v-for="item in inputs"
          :key="item.id"
          :style="item.maxWidth ? `max-width:${item.maxWidth}px; margin-bottom: 35px` : 'margin-bottom: 35px'"
          :prop="item.name")

          app-input(
            :placeholder="item.placeholder"
            :model="stateForm[item.name]"
            :name="item.name"
            :id="item.id"
            :label="item.label"
            :type="item.type"
            :prompt="item.prompt"
            :autosize="item.autosize"
            :maxlength="item.maxlength"
            :required="item.required"
            @input-value="modelValue")

    .activity__block.reverse
      .activity__block-wrapper
        h5 Активность:
        el-switch(
          v-model='category.active'
          active-color="#39D24E"
          :active-value='true'
          :inactive-value='false')

    .activity__block
      router-link.el-button.el-button--info.button(
      :to="{path: '/admin/categories'}")
        |Отмена

      el-button.button(
        type="success"
        @click="updateCategory('categoriesForm')")
        |Сохранить изменения

</template>

<script>
import InputItem from '../../../components/InputItem';

export default {
  layout: 'admin',
  name: 'CategoriesItem',
  components: {
    'app-input': InputItem
  },
  async asyncData(context) {
    let { data } = await context.$axios.get(
      `/api/v1/categories/${context.params.id}`
    );
    return { category: data };
  },
  data() {
    return {
      inputs: [
        {
          id: 1,
          placeholder: 'Укажите название категории',
          model: '',
          label: 'Название категории',
          name: 'name',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 2,
          placeholder: '',
          model: '',
          label: 'Cортировка',
          name: 'sort',
          type: 'sort',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, укажите параметры сортировки',
              trigger: 'change'
            }
          ]
        }
      ],
      pageLoading: false,
      updatedCategory: null
    };
  },
  computed: {
    stateForm() {
      let state = {};
      this.inputs.forEach(item => {
        if (
          item.name === 'sort' &&
          typeof this.category[item.name] === 'undefined'
        ) {
          state[item.name] = 100;
        } else {
          state[item.name] = this.category[item.name];
        }
      });
      return state;
    },
    rules() {
      let rulesObj = {};
      this.inputs.forEach(item => {
        rulesObj[item.name] = item.prop;
      });
      return rulesObj;
    }
  },
  created() {
    this.$store.commit('pages', [
      {
        name: 'Категории товаров',
        slug: '/admin/categories'
      }
    ]);
    this.$store.commit('headingTitle', 'Категория товаров');
    this.$store.commit('publicLink', `/catalog/${this.category.slug}`);
    this.$store.commit('id', this.category.id);
  },
  mounted() {
    this.inputs.forEach(item => {
      item.model = this.category[item.name];
    });
    if (this.category.updated_at) {
      this.updatedCategory = `${this.$moment(this.category.updated_at).format(
        'D.MM.YY'
      )}, в ${this.$moment(this.category.updated_at).format('H:mm')}`;
    }
  },
  methods: {
    modelValue(valueArr) {
      let index = this.inputs.findIndex(item => item.id === valueArr[0]);
      this.category[this.inputs[index].name] = valueArr[1];
      if (this.inputs[index].name === 'sort') {
        this.stateForm[this.inputs[index].name] = valueArr[1];
      }
    },
    updateCategory(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.pageLoading = true;
          this.$axios
            .patch(`/api/v1/categories/${this.$route.params.id}`, {
              name: this.stateForm.name,
              sort: this.stateForm.sort,
              active: this.category.active
            })
            .then(
              () => {
                this.pageLoading = false;
                this.$message.success('Новость успешно изменена!');
              },
              errorMessage => {
                console.log(errorMessage);
                this.$message.error('Ошибка перезаписи данных!');
                this.pageLoading = false;
              }
            )
            .catch(() => {
              this.$message.error('Ошибка перезаписи данных');
              this.pageLoading = false;
            });
        } else {
          this.$message.error('Пожалуйста, заполните все обязательные поля!');
          return false;
        }
      });
    }
  }
};
</script>
